## ros-foxy-tf2-ros 0.13.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(tf2_ros)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

if(NOT ANDROID)
  set(TF2_PY tf2_py)
endif()

find_package(ament_cmake REQUIRED)
find_package(builtin_interfaces REQUIRED)
find_package(geometry_msgs REQUIRED)
find_package(message_filters REQUIRED)
find_package(rcl_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rclcpp_action REQUIRED)
find_package(rclcpp_components REQUIRED)
find_package(tf2 REQUIRED)
find_package(tf2_msgs REQUIRED)

ament_python_install_package(${PROJECT_NAME} PACKAGE_DIR src/${PROJECT_NAME})

set(dependencies
  builtin_interfaces
  geometry_msgs
  message_filters
  rclcpp
  rclcpp_action
  tf2
  tf2_msgs
)

# tf2_ros library
add_library(${PROJECT_NAME} SHARED
  src/buffer.cpp
  src/create_timer_ros.cpp
  src/transform_listener.cpp
  src/buffer_client.cpp
  src/buffer_server.cpp
  src/transform_broadcaster.cpp
  src/static_transform_broadcaster.cpp
)
target_include_directories(${PROJECT_NAME} PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
ament_target_dependencies(${PROJECT_NAME}
  ${dependencies}
)

target_compile_definitions(${PROJECT_NAME} PRIVATE "TF2_ROS_BUILDING_DLL")

# buffer_server executable
add_executable(buffer_server src/buffer_server_main.cpp)
target_link_libraries(buffer_server
  ${PROJECT_NAME}
)
ament_target_dependencies(buffer_server
  ${dependencies}
)

add_library(static_transform_broadcaster_node SHARED
  src/static_transform_broadcaster_node.cpp
)
target_compile_definitions(static_transform_broadcaster_node PRIVATE "STATIC_TRANSFORM_BROADCASTER_BUILDING_DLL")
target_include_directories(static_transform_broadcaster_node PUBLIC
  "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
  "$<INSTALL_INTERFACE:include>")
target_link_libraries(static_transform_broadcaster_node ${PROJECT_NAME})
ament_target_dependencies(static_transform_broadcaster_node
  "geometry_msgs"
  "rclcpp"
  "rclcpp_components"
  "tf2_msgs"
)
rclcpp_components_register_nodes(static_transform_broadcaster_node "tf2_ros::StaticTransformBroadcasterNode")

# static_transform_publisher
add_executable(static_transform_publisher
  src/static_transform_broadcaster_program.cpp
)
target_link_libraries(static_transform_publisher
  ${PROJECT_NAME}
  static_transform_broadcaster_node
)
ament_target_dependencies(static_transform_publisher
  "geometry_msgs"
  "rclcpp"
  "tf2"
  "tf2_msgs"
)

add_executable(tf2_echo
  src/tf2_echo.cpp
)
target_link_libraries(tf2_echo
  ${PROJECT_NAME}
)
ament_target_dependencies(tf2_echo
  "geometry_msgs"
  "rclcpp"
  "tf2"
)

add_executable(tf2_monitor
  src/tf2_monitor.cpp
)
target_link_libraries(tf2_monitor
  ${PROJECT_NAME}
)
ament_target_dependencies(tf2_monitor
  ${dependencies}
)

# Install rules
install(TARGETS ${PROJECT_NAME}
  EXPORT ${PROJECT_NAME}
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

install(TARGETS static_transform_broadcaster_node
  EXPORT static_transform_broadcaster_node
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# install executables
install(TARGETS
  buffer_server
  static_transform_publisher
  tf2_echo
  tf2_monitor
  DESTINATION lib/${PROJECT_NAME}
)

install(DIRECTORY include/${PROJECT_NAME}/
  DESTINATION include/${PROJECT_NAME}
)

# Tests
if(BUILD_TESTING)
  find_package(ament_cmake_gtest REQUIRED)
  ament_add_gtest(test_buffer test/test_buffer.cpp)
  ament_target_dependencies(test_buffer
    ${dependencies}
  )
  target_link_libraries(test_buffer ${PROJECT_NAME})

  ament_add_gtest(test_buffer_server test/test_buffer_server.cpp)
  ament_target_dependencies(test_buffer_server
    ${dependencies}
  )
  target_link_libraries(test_buffer_server ${PROJECT_NAME})

  ament_add_gtest(test_buffer_client test/test_buffer_client.cpp)
  ament_target_dependencies(test_buffer_client
    ${dependencies}
  )
  target_link_libraries(test_buffer_client ${PROJECT_NAME})

  # Adds a tf2_ros message_filter unittest that uses
  # multiple target frames and a non-zero time tolerance
  ament_add_gtest(${PROJECT_NAME}_test_message_filter test/message_filter_test.cpp)
  ament_target_dependencies(${PROJECT_NAME}_test_message_filter
    ${dependencies}
  )
  target_link_libraries(${PROJECT_NAME}_test_message_filter ${PROJECT_NAME})

  ament_add_gtest(${PROJECT_NAME}_test_transform_listener test/test_transform_listener.cpp)
  ament_target_dependencies(${PROJECT_NAME}_test_transform_listener
    ${dependencies}
  )
  target_link_libraries(${PROJECT_NAME}_test_transform_listener ${PROJECT_NAME})

  ament_add_gtest(${PROJECT_NAME}_test_static_transform_broadcaster test/test_static_transform_broadcaster.cpp)
  ament_target_dependencies(${PROJECT_NAME}_test_static_transform_broadcaster
    rclcpp
  )
  target_link_libraries(${PROJECT_NAME}_test_static_transform_broadcaster ${PROJECT_NAME})

  ament_add_gtest(${PROJECT_NAME}_test_transform_broadcaster test/test_transform_broadcaster.cpp)
  ament_target_dependencies(${PROJECT_NAME}_test_transform_broadcaster
    rclcpp
  )
  target_link_libraries(${PROJECT_NAME}_test_transform_broadcaster ${PROJECT_NAME})

  ament_add_gtest(${PROJECT_NAME}_test_time_reset test/time_reset_test.cpp)
  ament_target_dependencies(${PROJECT_NAME}_test_time_reset
    ${dependencies}
    rosgraph_msgs
  )
  target_link_libraries(${PROJECT_NAME}_test_time_reset ${PROJECT_NAME})

  ament_add_gtest(${PROJECT_NAME}_test_listener test/listener_unittest.cpp)
  ament_target_dependencies(${PROJECT_NAME}_test_listener
    builtin_interfaces
    geometry_msgs
    rclcpp
    tf2
  )
  target_link_libraries(${PROJECT_NAME}_test_listener ${PROJECT_NAME})

  # Python test
  # Provides PYTHON_EXECUTABLE_DEBUG
  find_package(python_cmake_module REQUIRED)
  find_package(PythonExtra REQUIRED)

  set(_PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE}")
  if(WIN32 AND CMAKE_BUILD_TYPE STREQUAL "Debug")
    set(PYTHON_EXECUTABLE "${PYTHON_EXECUTABLE_DEBUG}")
  endif()

  find_package(ament_cmake_pytest REQUIRED)
  ament_add_pytest_test(tf2_ros_py_test test/py_test)

  set(PYTHON_EXECUTABLE "${_PYTHON_EXECUTABLE}")
endif()

ament_export_include_directories(include)
ament_export_libraries(${PROJECT_NAME} static_transform_broadcaster_node)
ament_export_targets(${PROJECT_NAME} static_transform_broadcaster_node)
ament_export_dependencies(
  ${dependencies}
  rcl_interfaces
  rclcpp_components
)
ament_package()

=== debian/changelog ===
ros-foxy-tf2-ros (0.13.14-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Thu, 16 Mar 2023 00:00:00 -0000

ros-foxy-tf2-ros (0.13.13-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Mon, 31 Jan 2022 00:00:00 -0000

ros-foxy-tf2-ros (0.13.12-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 05 Oct 2021 00:00:00 -0000

ros-foxy-tf2-ros (0.13.11-1focal) focal; urgency=high

  * Fix tf2_echo does not work with ros-args (#407 <https://github.com/ros2/geometry2/issues/407>) (#408 <https://github.com/ros2/geometry2/issues/408>) (#411 <https://github.com/ros2/geometry2/issues/411>)
  * Avoid using invalid std::list iterators (#293 <https://github.com/ros2/geometry2/issues/293>) (#419 <https://github.com/ros2/geometry2/issues/419>)
  * Fix accessing free'd resources (#386 <https://github.com/ros2/geometry2/issues/386>) (#419 <https://github.com/ros2/geometry2/issues/419>)
  * Contributors: Chris Lalancette, Kazunari Tanaka, Michael Carroll, PGotzmann, simutisernestas

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 31 Aug 2021 00:00:00 -0000

ros-foxy-tf2-ros (0.13.10-1focal) focal; urgency=high

  * Update for python3.8 (#359 <https://github.com/ros2/geometry2/issues/359>)
  * Contributors: Fabrice Larribe

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 14 Apr 2021 00:00:00 -0000

ros-foxy-tf2-ros (0.13.9-1focal) focal; urgency=high



 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 09 Dec 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.8-1focal) focal; urgency=high

  * Generate callbacks after updating message_ (#274 <https://github.com/ros2/geometry2/issues/274>) (#353 <https://github.com/ros2/geometry2/issues/353>)
    * Generate callbacks after updating message_
    * Add test for multithread TransformListener to test_message_filter
    Co-authored-by: ymd-stella <mailto:7959916+ymd-stella@users.noreply.github.com>
  * Contributors: Jacob Perron

 -- Chris Lalancette <clalancette@openrobotics.org>  Tue, 08 Dec 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.7-1focal) focal; urgency=high

  * [Foxy backport] Fixed memory leak in Buffer::waitForTransform (#281 <https://github.com/ros2/geometry2/issues/281>) (#330 <https://github.com/ros2/geometry2/issues/330>)
  * Contributors: Matthijs den Toom

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 18 Nov 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.6-1focal) focal; urgency=high

  * Update maintainers of the ros2/geometry2 fork. (#328 <https://github.com/ros2/geometry2/issues/328>) (#332 <https://github.com/ros2/geometry2/issues/332>)
  * Clear callbacks_to_remove variable after removing (#314 <https://github.com/ros2/geometry2/issues/314>)
  * Add pytest.ini to tf2_ros
  * Contributors: Alejandro Hernández Cordero, Jacob Perron, Matthijs den Toom

 -- Chris Lalancette <clalancette@openrobotics.org>  Wed, 28 Oct 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.5-1focal) focal; urgency=high

  * Make static_transform_broadcaster consistent with its command line description (#294 <https://github.com/ros2/geometry2/issues/294>) (#296 <https://github.com/ros2/geometry2/issues/296>)
  * Fix dependencies in tf2_ros (#269 <https://github.com/ros2/geometry2/issues/269>) (#288 <https://github.com/ros2/geometry2/issues/288>)
  * Moved unique_lock of messages_mutex_ to guarantee pointer (#279 <https://github.com/ros2/geometry2/issues/279>) (#283 <https://github.com/ros2/geometry2/issues/283>)
  * Contributors: Chris Lalancette, Hunter L. Allen, Martin Ganeff

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 05 Aug 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.4-1focal) focal; urgency=high

  * export targets in addition to include directories / libraries (#271 <https://github.com/ros2/geometry2/issues/271>)
  * Add missing virtual destructors (#272 <https://github.com/ros2/geometry2/issues/272>)
  * Contributors: Dirk Thomas, Ivan Santiago Paunovic

 -- Tully Foote <tfoote@osrfoundation.org>  Wed, 03 Jun 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.3-1focal) focal; urgency=high

  * Fixed in Exception constructor tf2_ros (#267 <https://github.com/ros2/geometry2/issues/267>)
  * Contributors: Alejandro Hernández Cordero

 -- Tully Foote <tfoote@osrfoundation.org>  Tue, 26 May 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.2-1focal) focal; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Mon, 18 May 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.1-1focal) focal; urgency=high



 -- Tully Foote <tfoote@osrfoundation.org>  Fri, 08 May 2020 00:00:00 -0000

ros-foxy-tf2-ros (0.13.0-1focal) focal; urgency=high

  * Added doxyfiles and sphinx Makefiles (#257 <https://github.com/ros2/geometry2/issues/257>)
  * avoid more deprecations (#255 <https://github.com/ros2/geometry2/issues/255>)
  * create_timer takes shared pointers (#251 <https://github.com/ros2/geometry2/issues/251>)
  * Improve tf2_echo and tf2_monitor messages while waiting for data (#254 <https://github.com/ros2/geometry2/issues/254>)
  * Add missing visibility header include (#246 <https://github.com/ros2/geometry2/issues/246>)
  * Fix -Wrange-loop-construct (#245 <https://github.com/ros2/geometry2/issues/245>)
    ```
    --- stderr: tf2_ros
    /opt/ros/master/src/ros2/geometry2/tf2_ros/test/test_buffer.cpp:84:21: warning: loop variable 'elem' creates a copy from type 'const std::pair<const unsigned long, std::function<void (const unsigned long &)> >' [-Wrange-loop-construct]
    for (const auto elem : timer_to_callback_map\_) {
    ^
    /opt/ros/master/src/ros2/geometry2/tf2_ros/test/test_buffer.cpp:84:10: note: use reference type 'const std::pair<const unsigned long, std::function<void (const unsigned long &)> > &' to prevent copying
    for (const auto elem : timer_to_callback_map\_) {
    ^~~~~~~~~~~~~~~~~
    &
    1 warning generated.
    ---
    ```
  * Remove TODO (#234 <https://github.com/ros2/geometry2/issues/234>)


=== debian/control ===
Source: ros-foxy-tf2-ros
Section: misc
Priority: optional
Maintainer: Chris Lalancette <clalancette@openrobotics.org>
Build-Depends: debhelper (>= 9.0.0), ros-foxy-ament-cmake, ros-foxy-ament-cmake-gtest <!nocheck>, ros-foxy-ament-cmake-pytest <!nocheck>, ros-foxy-ament-cmake-python, ros-foxy-builtin-interfaces, ros-foxy-geometry-msgs, ros-foxy-message-filters, ros-foxy-python-cmake-module, ros-foxy-rcl-interfaces, ros-foxy-rclcpp, ros-foxy-rclcpp-action, ros-foxy-rclcpp-components, ros-foxy-rclpy, ros-foxy-std-msgs, ros-foxy-tf2, ros-foxy-tf2-msgs, ros-foxy-tf2-py, ros-foxy-ros-workspace
Homepage: http://www.ros.org/wiki/tf2_ros
Standards-Version: 3.9.2

Package: ros-foxy-tf2-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-foxy-builtin-interfaces, ros-foxy-geometry-msgs, ros-foxy-message-filters, ros-foxy-rcl-interfaces, ros-foxy-rclcpp, ros-foxy-rclcpp-action, ros-foxy-rclcpp-components, ros-foxy-rclpy, ros-foxy-std-msgs, ros-foxy-tf2, ros-foxy-tf2-msgs, ros-foxy-tf2-py, ros-foxy-ros-workspace
Description: This package contains the ROS bindings for the tf2 library, for both Python and C++.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/foxy/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/foxy" \
		-DAMENT_PREFIX_PATH="/opt/ros/foxy" \
		-DCMAKE_PREFIX_PATH="/opt/ros/foxy" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-foxy-tf2-ros//opt/ros/foxy/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/foxy/setup.sh" ]; then . "/opt/ros/foxy/setup.sh"; fi && \
	dh_auto_install
